Unit Buttons;

Interface

Const
  max_button = 16;
  max_string = 32;
  button_keyb_delay = 20;
Type
  button = Record
             x,y,l : Byte;
             txt : String[max_string];
             k : Char;
           End;
  pbutton = ^button;
  bset = Array [1..max_button] Of ^button;

Procedure Draw_set (Var b : bset);
Function Check_set (Var b : bset; mx,my : Byte; chkey : Char) : Byte;
Function Choice (title,invite : String; Var b : bset) : Byte;

Implementation

Uses Keyb,Mouse,Timer,Txt;

Procedure Draw_set (Var b : bset);
Const
  shad : String[20] = '';
Var
  a : Byte;
Begin
  Hide_mouse;
  For a :=1 To max_button Do
    If b[a]<>nil Then
    With b[a]^ Do
      Begin
        shad[0] :=Chr (l);
        Text (x,y,#0#112+txt+#0#16+'');
        Text (x+1,y+1,#0#16+shad);
      End;
  Show_mouse;
End;

Function Check_set (Var b : bset; mx,my : Byte; chkey : Char) : Byte;
Const
  void : String[20] = '                    ';
  shad : String[20] = '';
Var
  off,z : Boolean;
  a,mc,res : Byte;
Begin
  res :=0;
  a :=1;
  Repeat
    If b[a]<>nil Then
    With b[a]^ Do
      If ((my=y) And (mx>=x) And (mx<x+l) And (chkey=#0)) Or (chkey=k) Then
      Begin
        off :=True;
        shad[0] :=Chr (l);
        void[0] :=Chr (l);
        Repeat
          z :=(my=y) And (mx>=x) And (mx<x+l) And (chkey=#0);
          If (off And z) Or (chkey<>#0) Then
          Begin
            Hide_mouse;
            Text (x,y,#0#16' '#0#112+txt);
            Text (x+1,y+1,#0#16+void);
            Show_mouse;
            off :=False;
            If (chkey<>#0) Then
              Delay (button_keyb_delay);
          End;
          If (Not off) And (Not z) And (chkey=#0) Then
          Begin
            Hide_mouse;
            Text (x,y,#0#112+txt+#0#16+'');
            Text (x+1,y+1,#0#16+shad);
            Show_mouse;
            off :=True;
          End;
          Get_mouse_XY (mx,my);
        Until (Get_mouse_clic=0) Or (chkey<>#0);
        If Not off Then
        Begin
          Hide_mouse;
          Text (x,y,#0#112+txt+#0#16+'');
          Text (x+1,y+1,#0#16+shad);
          Show_mouse;
        End;
        If ((my=y) And (mx>=x) And (mx<x+l) And (chkey=#0)) Or (chkey<>#0) Then
          res :=a;
      End;
    Inc (a);
  Until (a>max_button) Or (res>0);
  Check_set :=res;
End;

Function Choice (title,invite : String; Var b : bset) : Byte;
Var
  a,l,mx,my,x1 : Byte;
  ch : Char;
Begin
  l :=Length (title);
  If l<Length (invite) Then l :=Length (invite);
  x1 :=39-l Shr 1;
  Hide_mouse;
  Dialog (x1,10,x1+l+1,14,title);
  Text (40-Length (invite) Shr 1,11,invite);
  Draw_set (b);
  Show_mouse;
  a :=0;
  Repeat
    Get_mouse_XY (mx,my);
    If (Get_mouse_clic=1) Or Key (ch) Then
      a :=Check_set (b,mx,my,ch);
  Until a>0;
  Choice :=a;
  End_dialog;
End;

End.
