Unit Keyb;

Interface

Function KeyPressed : Boolean;
Function ReadKey : Char;
Function Key (Var ch : Char) : Boolean;

Implementation

Uses Txt;

Function KeyPressed : Boolean; Assembler;
Asm
  mov  ah,01h
  int  16h
  mov  al,0
  jz   @no_stroke
       inc  al
  @no_stroke:
End;

Function ReadKey : Char; Assembler;
Asm
  xor  ah,ah
  int  16h
  or   al,al
  jnz  @no_special
       or   ah,80h
       mov  al,ah
  @no_special:
End;

Function Key (Var ch : Char) : Boolean;
Begin
  If KeyPressed Then
    Begin
      Key :=True;
      ch :=UpCaseCh (ReadKey);
    End
  Else
    Begin
      Key :=False;
      ch :=#0;
    End;
End;

End.